#ifndef _DB_HELPER_H_
#define _DB_HELPER_H_

#include "db_cxx.h"

extern "C" {
    int _dbenv_create__(DbEnv** dbenv, u_int32_t flags);
    int _dbenv_get_lk_max_lockers(DbEnv *dbenv, u_int32_t *lk_maxp);
    int _dbenv_set_lk_max_lockers(DbEnv *dbenv, u_int32_t max);
    int _dbenv_get_lk_max_locks(DbEnv *dbenv, u_int32_t *lk_maxp);
    int _dbenv_set_lk_max_locks(DbEnv *dbenv, u_int32_t max);
    int _dbenv_get_lk_max_objects(DbEnv *dbenv, u_int32_t *lk_maxp);
    int _dbenv_set_lk_max_objects(DbEnv *dbenv, u_int32_t max);
    int _dbenv_get_tx_max(DbEnv *dbenv, u_int32_t *lk_maxp);
    int _dbenv_set_tx_max(DbEnv *dbenv, u_int32_t max);
    int _dbenv_get_cachesize(DbEnv *dbenv, u_int32_t *gbytesp, u_int32_t *bytesp, int *ncachep);
    int _dbenv_set_cachesize(DbEnv *dbenv, u_int32_t gbytes, u_int32_t bytes, int ncache);
    int _dbenv_get_lg_regionmax(DbEnv *dbenv, u_int32_t *lk_maxp);
    int _dbenv_set_lg_regionmax(DbEnv *dbenv, u_int32_t max);
    int _dbenv_open(DbEnv *dbenv, char *db_home, u_int32_t flags, int mode);
    int _db_create(DbEnv* dbenv, u_int32_t flags, Db** db);
    void _db_delete(Db* db);
    int _db_set_pagesize(Db* db, u_int32_t pagesize);
    int _db_open(Db* db, DbTxn* txn, const char* file, const char* database,
        int type, u_int32_t flags, int mode);
    int _dbenv_txn_begin(DbEnv* dbenv, DbTxn* parent, DbTxn** txn, u_int32_t flags);
    int _dbenv_txn_checkpoint(DbEnv* dbenv, u_int32_t kbyte, u_int32_t min, u_int32_t flags);
    int _dbtxn_abort(DbTxn* dbtxn);
    int _dbtxn_commit(DbTxn* dbtxn, u_int32_t flags);
    void _dbtxn_delete(DbTxn* dbtxn);
    u_int32_t _dbtxn_id(DbTxn* dbtxn);
    void _dblock_delete(DbLock* dblock);
    int _dbenv_lock_get(DbEnv* dbenv, u_int32_t lockerID, u_int32_t flags,
        const char* object, u_int32_t object_len, u_int32_t lockmode, DbLock** dblock);
    int _dbenv_lock_put(DbEnv* dbenv, DbLock* dblock);
    void _deleteString(char* str);
    void _freeString(char* str);
    int _db_get(Db* db, DbTxn* dbtxn, const char* key, u_int32_t key_len, char** value, u_int32_t* value_len, u_int32_t flags);
    int _db_put(Db* db, DbTxn* dbtxn, const char* key, u_int32_t key_len, char* value, u_int32_t value_len, u_int32_t flags);
    int _db_close(Db* db, u_int32_t flags);
    int _dbenv_close(DbEnv* dbEnv, u_int32_t flags);
}

#endif

